const fs = require('fs');
const path = require('path');
const { mkdirpSync, copySync } = require('fs-extra');
const getModuleEntry = require('../utils/getModuleEntry');
const getModule = require('../utils/getModule');

module.exports = (cwd, moduleKey, target) => {
  const moduleEntry = getModuleEntry(moduleKey);
  const source = getModule(moduleEntry);

  if (source.type === 0) {
    target = path.resolve(cwd, target);
    const targetDir = path.dirname(target);
    if (!fs.existsSync(targetDir)) {
      mkdirpSync(targetDir);
    }

    copySync(path.resolve(source.base, source.entry), target);

    console.log('success.');
  } else if (source.type === 1) {
    target = path.resolve(cwd, target);
    if (fs.existsSync(target) && !fs.statSync(target).isDirectory()) {
      throw new Error(`${target} is not a directory`);
    }

    if (!fs.existsSync(target)) {
      mkdirpSync(target);
    }

    const originList = fs.readdirSync(target);
    console.log(`exists ${originList.length} files`);

    copySync(source.base, target, { filter: (src, dest) => {
        if (src.match(/\.DS_Store$/)) {
          return;
        }

        if (src.match(/node_modules$/)) {
          return;
        }

        if (src.match(/test$/)) {
          return;
        }

        if (src.match(/dep$/)) {
          return;
        }

        return true;
      }});

    console.log('success.');
  }
};
