const fs = require('fs');
const path = require('path');
const recursionDir = require('./recursionDir');

const getModule = (file) => {
  const buffer = Buffer.alloc(1000);
  const fd = fs.openSync(file, 'r');
  fs.readSync(fd, buffer, 0, 100);
  fs.closeSync(fd);

  let content = buffer.toString();
  content = content.replace(/^\s/mg, '');
  content = content.match(/\/\*\*\n\* @CodeSnippet@\n((.|\n)*)\*\//);
  content = content && content[1] || '';

  const params = {};
  content = content.split('\n').forEach(item => {
    item = item.match(/@(.*)\: (.*)/);
    if (item) {
      params[item[1]] = item[2];
    }
  });

  if (!params.module) {
    return;
  }

  const dirName = path.dirname(file);
  const extname = path.extname(file);
  const basename = path.basename(file, extname);
  const moduleName = params.module.split(':')[1];
  //  && dirName.split(path.sep).pop() === moduleName
  if (basename === 'index') {
    params.base = dirName;
    params.type = 1;
    params.entry = `index${extname}`;
    params.files = [
      ...recursionDir(dirName, true, item => !item.match(/(\.DS_Store|node_modules|test|dep)$/)),
    ];
  } else {
    params.base = dirName;
    params.type = 0;
    params.entry = path.relative(dirName, file);
    params.files = [
      params.entry,
    ]
  }

  return params;
};

module.exports = getModule;
