const fs = require('fs');
const path = require('path');
const getSourceBase = require('../utils/getSourceBase');

module.exports = (moduleKey) => {
  const base = getSourceBase();

  const key = moduleKey.split(':');
  if (key.length !== 2) {
    throw new Error(`error module "${moduleKey}"`);
  }

  const moduleName = key[1];
  const moduleDir = path.resolve(base, key.join('/'));
  const singleModulePath = path.resolve(moduleDir, `${moduleName}.js`);
  if (fs.existsSync(singleModulePath)) {
    return singleModulePath;
  }

  const multiModulePath = path.resolve(moduleDir, 'index.js');
  if (fs.existsSync(multiModulePath)) {
    return multiModulePath;
  } else if (moduleKey.match(/^react:/)) {
    const multiModulePath = path.resolve(moduleDir, 'index.jsx');
    if (fs.existsSync(multiModulePath)) {
      return multiModulePath;
    }
  }

  throw new Error(`can\\'t find module "${moduleKey}"`);
};
