const path = require('path');
const fs = require('fs');

const recursionDir = (node, ignoreDirectory, filter) => {
  const recursion = (node, filter, result) => {
    if (!fs.existsSync(node)) {
      return;
    }

    if (typeof filter === 'function' && !filter(node)) {
      return;
    }

    const isDirectory = fs.statSync(node).isDirectory();
    if (!(isDirectory && !!ignoreDirectory)) {
      result.push(node);
    }

    if (isDirectory) {
      fs.readdirSync(node).forEach(item => {
        const childNode = path.resolve(node, item);
        recursion(childNode, filter, result);
      });
    }
  };

  const result = [];
  recursion(node, filter, result);

  result.forEach((item, i) => {
    result[i] = path.relative(node, item);
  });

  return result;
};

module.exports = recursionDir;
